// Created by John Liaperdos and George Theophanous, July 2015

var VGS=0;
var VDS=0;
var IDS=0;
var VT=1;
var beta=8; // such as to give Ids=100mA at VGS=6V (for VT=1V)
var VGS_colors=['#008000', '#800000', '#000000', '#0000ff', '#ff6600', '#666666', '#808000' ];
// plot area rectangle coordinates
	var screen_x_min=66.670074;
	var screen_y_min=190;
	var screen_x_max=373.32263;
	var screen_y_max=341.5;
// plot ranges
	var range_x_min=0;
	var range_x_max=13;
	var range_y_min=0;
	var range_y_max=100;

var measurements = new Array(7); //VGS values (0-6)
for (var i = 0; i < 7; i++) 
{
	measurements[i] = new Array(13); //VDS values (0-12)
	for (var j = 0; j < 13; j++)
	{
		measurements[i][j] = -1; //IDS : "-1" indicates that no measurement has been added
	}
}

function initializeMOSFETCharacteristics(){
	for(i=0;i<7;i++)
	{
		document.getElementById('VGS'+i+'_label').style.display='none';
	}
	document.getElementById('message_text').textContent='';
	document.getElementById('VGS_text').textContent=0;
	document.getElementById('VGS_text').style.fill=VGS_colors[0];
	document.getElementById('color_indicator').style.fill=VGS_colors[0];
	document.getElementById('VDS_text').textContent=0;	
	document.getElementById('IDS_text').textContent=0;
	IDS=MOSFETcurrent(VGS,VDS);
}

function MOSFETcurrent(vgs_val,vds_val){
	if(vgs_val<VT) mosfet_current=0; // cutoff
	if(vgs_val>=VT)
	{
		if(vds_val<=(vgs_val-VT)) 
		{
			mosfet_current=beta*(vds_val*(vgs_val-VT)-vds_val*vds_val/2); //triode
		}
		else
		{
			mosfet_current=beta*(vgs_val-VT)*(vgs_val-VT)/2; //saturation
		};
	};
	return mosfet_current;
}

function addPoint(){
	//check if point has been already added	
		if(measurements[VGS][VDS]!=-1)
		{
			document.getElementById('message_text').style.fill='red';
			document.getElementById('message_text').textContent='Η μέτρηση έχει ήδη προστεθεί';
		}
		else
		{
			measurements[VGS][VDS]=IDS;
			document.getElementById('message_text').style.fill='green';
			document.getElementById('message_text').textContent='Η μέτρηση προστέθηκε';	
			document.getElementById('VGS'+VGS+'_label').style.display='inline';
			plotPoint();
			// also plot line if enough points exist
				count_points=0;
				for (i=0;i<13;i++)
				{
					if(measurements[VGS][i]>-1)
					{
						count_points=count_points+1;
					}
				}
				if(count_points==13)
				{
					connectPoints(VGS);
				}
		}
}

function plotPoint(){
	var point_container=document.getElementById('VGS'+VGS+'_plot_container');
	var new_ellipse = document.createElementNS("http://www.w3.org/2000/svg", "ellipse");
	new_ellipse.setAttribute('cx', xformX(VDS));
	new_ellipse.setAttribute('cy', xformY(IDS));
	new_ellipse.setAttribute('rx', '3');
	new_ellipse.setAttribute('ry', '3');	
	new_ellipse.setAttribute('style', 'fill:'+VGS_colors[VGS]+';stroke:'+VGS_colors[VGS]+';stroke-width:2');
	point_container.appendChild(new_ellipse);
}

function clearPlots(){
	for(i=0;i<7;i++)
	{
		document.getElementById('VGS'+i+'_label').style.display='none';
		var point_container=document.getElementById('VGS'+i+'_plot_container');
		while (point_container.hasChildNodes()) {
			point_container.removeChild(point_container.lastChild);
		}
		for (var j = 0; j < 13; j++)
		{
			measurements[i][j] = -1; 
		}
	}
	document.getElementById('message_text').textContent='';
}

function connectPoints(vgs_val){
	if(vgs_val==100) 
	{
		imin=0;
		imax=7;
	}
	else
	{
		imin=vgs_val;
		imax=vgs_val+1;
	}
	for(i=imin;i<imax;i++)
	{
		if(vgs_val==100)
		{
			document.getElementById('VGS'+i+'_label').style.display='inline';
		};
		use_color=VGS_colors[i];
		for (var j = 0; j < 12; j=j+0.2)
		{
			var plot_container=document.getElementById('VGS'+i+'_plot_container');
			var new_line = document.createElementNS("http://www.w3.org/2000/svg", "line");
			new_line.setAttribute('x1', xformX(j));
			new_line.setAttribute('y1', xformY(MOSFETcurrent(i,j)));
			new_line.setAttribute('x2', xformX(j+0.2));
			new_line.setAttribute('y2', xformY(MOSFETcurrent(i,j+0.2)));	
			new_line.setAttribute('style', 'fill:'+VGS_colors[i]+';stroke:'+VGS_colors[i]+';stroke-width:2');
			plot_container.appendChild(new_line);			
		}
	}
	document.getElementById('message_text').textContent='';
}

function increaseVGS(){
	if(VGS<6)
	{
		VGS=VGS+1;
	}
	document.getElementById('VGS_text').textContent=VGS;
	document.getElementById('VGS_text').style.fill=VGS_colors[VGS];
	document.getElementById('color_indicator').style.fill=VGS_colors[VGS];
	IDS=MOSFETcurrent(VGS,VDS);
	document.getElementById('IDS_text').textContent=Math.round(IDS*100)/100;
	document.getElementById('message_text').textContent='';	
}

function decreaseVGS(){
	if(VGS>0)
	{
		VGS=VGS-1;
	}
	document.getElementById('VGS_text').textContent=VGS;
	document.getElementById('VGS_text').style.fill=VGS_colors[VGS];
	document.getElementById('color_indicator').style.fill=VGS_colors[VGS];
	IDS=MOSFETcurrent(VGS,VDS);
	document.getElementById('IDS_text').textContent=Math.round(IDS*100)/100;
	document.getElementById('message_text').textContent='';
}

function increaseVDS(){
	if(VDS<12)
	{
		VDS=VDS+1;
	}
	document.getElementById('VDS_text').textContent=VDS;
	IDS=MOSFETcurrent(VGS,VDS);
	document.getElementById('IDS_text').textContent=Math.round(IDS*100)/100;
	document.getElementById('message_text').textContent='';
}

function decreaseVDS(){
	if(VDS>0)
	{
		VDS=VDS-1;
	}
	document.getElementById('VDS_text').textContent=VDS;
	IDS=MOSFETcurrent(VGS,VDS);
	document.getElementById('IDS_text').textContent=Math.round(IDS*100)/100;
	document.getElementById('message_text').textContent='';
}

function xformX(x_val){
	x_transformed=screen_x_min+(x_val-range_x_min)*(screen_x_max-screen_x_min)/(range_x_max-range_x_min);
	return x_transformed;
}

function xformY(y_val){
	y_transformed=screen_y_max-(y_val-range_y_min)*(screen_y_max-screen_y_min)/(range_y_max-range_y_min);
	return y_transformed;
}


